Subject: Re: [tcpm] [EXTERNAL] Re: [Technical Errata Reported] RFC8257 (6697)

From: Bob Briscoe <[email-masked]>
Date: Fri, 1 Oct 2021 13:43:41 +0100

Praveen, [re-sending with trimmed distro to avoid rejection by list]

On 30/09/2021 22:14, Praveen Balasubramanian wrote:
>
> Trying to send my old response again as it got stuck in moderation.
>
> Great catch Vidhi!
>
> We don’t need to change the section numbers. ECE is processed on 
> acceptable ACK packets and there is already another bullet 3 which 
> specifies that condition:
>
> 3.  If the ECE flag is set, update the bytes marked:
>
>           DCTCP.BytesMarked += BytesAcked
>
> So all we need is:
>
>   9.  If the ECE flag is set, rather than always halving the 
> congestion window as described in
>
>        [RFC3168 <https://datatracker.ietf.org/doc/html/rfc3168>], the 
> sender SHOULD update cwnd as follows:
>
>           cwnd = cwnd * (1 - DCTCP.Alpha / 2)
>
> I don’t think we need the additional explanation of how to implement 
> the once per window reaction, even RFC 3168 does not specify those 
> details.
>

[BB] OK, maybe we don't need a new subsection. But the problem starts at 
item 4, which says:

    4.  If the acknowledgment number is less than or equal to
        DCTCP.WindowEnd, stop processing.  Otherwise, the end of the
        observation window has been reached, so proceed to update the
        congestion estimate as follows:

This says that the subsequent items in the list are only executed if 
(ackno > DCTCP.WindowEnd).
So, steps 5-8 really needed to be sub-bullets of step 4. And step 9 
would be renumbered step 5.

If we just add  "If the ECE flag is set" to step 9, it will mean that 
both conditions have to be met (ackno > DCTCP.WindowEnd && ECE), which 
is not what was intended. So the structure has to be changed somehow, 
not just some words.

I'm aware that RFC 3168 doesn't say anything about CWR state. Indeed, I 
checked RFC3168 before suggesting this sentence about CWR state, which 
was included to match the level of detail in the previous bullets about 
how the observation window is checked.

I won't fight for the final sentence that I suggested (the one 
explaining that the two periods are unrelated).

I suggest Vidhi would be the best judge of how much detail is needed, 
'cos she's reading it with fresh eyes, so she can say what she didn't 
understand.

Bob

> *From:* Vidhi Goel <[email-masked]>
> *Sent:* Thursday, September 30, 2021 2:07 PM
> *To:* Bob Briscoe <[email-masked]>
> *Cc:* RFC Errata System <[email-masked]>; 
> [email-masked]; Dave Thaler <[email-masked]>; Praveen 
> Balasubramanian <[email-masked]>; [email-masked]; 
> [email-masked]; Martin Duke <[email-masked]>; 
> [email-masked]; [email-masked]; 
> Michael Tuexen <[email-masked]>; [email-masked]; [email-masked]
> *Subject:* [EXTERNAL] Re: [tcpm] [Technical Errata Reported] RFC8257 
> (6697)
>
> Thank you Bob for providing a complete suggestion.
>
> Section 3.3 is titled */Processing Echoed Congestion Indications on 
> the Sender, /*so probably this should include Congestion Window 
> Reduction as well. That’s why I suggested to create two sub-sections.
>
>
>
> Alternatively, we can also use your suggestion by re-titling Section 
> 3.3, something like,
>
> Section 3.3 Computing Moving Average of ECN Feedback
>
> Section 3.4 Reducing Congestion Window based on ECN Feedback
>
> Section 3.5 Handling of Congestion Window Growth
>
> …
>
> Thanks,
>
> Vidhi
>
>
>
>     On Sep 30, 2021, at 4:48 AM, Bob Briscoe <[email-masked]
>     <mailto:[email-masked]>> wrote:
>
>     Vidhi,
>
>     You're right. It's incorrect to have the window reduction hanging
>     off the end of the list of steps for updating the EWMA.
>
>     To make this concrete, here's some specific additional text (in
>     green for those with HTML mail readers). Also, rather than
>     splitting into sub-subsections, I have suggested that Item 9. of
>     the list in subsection 3.3 is moved out of the list, and instead
>     forms the basis of a new subsection 3.4. entitled "Congestion
>     Window Reduction".
>
>     CURRENT:
>     ========
>
>         9.  Rather than always halving the congestion window as described in
>
>             [RFC3168], the sender SHOULD update cwnd as follows:
>
>                cwnd = cwnd * (1 - DCTCP.Alpha / 2)
>
>         Just as specified in [RFC3168], DCTCP does not react to congestion
>
>         indications more than once for every window of data.  The setting of
>
>         the CWR bit is also as per [RFC3168].  This is required for
>
>         interoperation with classic ECN receivers due to potential
>
>         misconfigurations.
>
>     3.4.  Handling of Congestion Window Growth...
>
>     SUGGESTED:
>     ==========
>
>     *3.4. Congestion Window Reduction*
>
>         Rather than always halving the congestion window as described in
>
>         [RFC3168]*, on the arrival of congestion feedback,*  the sender SHOULD
>
>         update cwnd as follows:
>
>            cwnd = cwnd * (1 - DCTCP.Alpha / 2)
>
>         Just as specified in [RFC3168], DCTCP does not react to congestion
>
>         indications more than once for every window of data.*Therefore, as *
>
>     *   for RFC3168 ECN, it sets the variable for the end of congestion*
>
>     *   window reduced (CWR) state to SND.UNA and suppresses further*
>
>     *   reductions until this TCP sequence number is acknowledged. Periods*
>
>     *   of CWR state are triggered by congestion feedback, and therefore*
>
>     *   occur at times unrelated to the continuous cycle of observation*
>
>     *   windows used to update DCTCP.Alpha in Section 3.3.*
>
>         The setting of the CWR bit is also as per [RFC3168].  This is
>
>         required for interoperation with classic ECN receivers due to
>
>         potential misconfigurations.
>
>     3.*5*.  Handling of Congestion Window Growth...
>
>
>     Then the of numbering all subsequent subsections of section 3.
>     will increment by 0.1.
>
>
>
>     Bob
>
>     On 28/09/2021 08:18, RFC Errata System wrote:
>
>         The following errata report has been submitted for RFC8257,
>
>         "Data Center TCP (DCTCP): TCP Congestion Control for Data Centers".
>
>         --------------------------------------
>
>         You may review the report below and at:
>
>         https://www.rfc-editor.org/errata/eid6697  <https://nam06.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.rfc-editor.org%2Ferrata%2Feid6697&data=04%7C01%7Cpravb%40microsoft.com%7C6adfa975d9744f6a289b08d984564c71%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637686328526119642%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=xqxUAHtiFNrST8HTP5sWFhpDq2SJ2%2Bsl8tQ%2Byh1OaUM%3D&reserved=0>
>
>         --------------------------------------
>
>         Type: Technical
>
>         Reported by: Vidhi Goel<[email-masked]>  <mailto:[email-masked]>
>
>         Section: 3.3
>
>         Original Text
>
>         -------------
>
>         The below pseudocode follows after DCTCP.Alpha is updated on ACK processing. This is wrong as cwnd should only be reduced using DCTCP.Alpha when ECE is received.
>
>         9. Rather than always halving the congestion window as described in
>
>                 [RFC3168], the sender SHOULD update cwnd as follows:
>
>                    cwnd = cwnd * (1 - DCTCP.Alpha / 2)
>
>         Corrected Text
>
>         --------------
>
>         Instead, a new paragraph for Congestion Response to ECN feedback would be much clearer. First start with RFC 3168's response to ECE and then provide DCTCP's response to ECE.
>
>         I am thinking splitting section 3.3 into two sub-sections -
>
>         3.3.1 Computation of DCTCP.Alpha
>
>         3.3.2 Congestion Response to ECE at sender
>
>         Notes
>
>         -----
>
>         Although RFC 8257 refers to RFC 3168 congestion window halving at step 9, but it is confusing to put it right after step 8.
>
>         Instructions:
>
>         -------------
>
>         This erratum is currently posted as "Reported". If necessary, please
>
>         use "Reply All" to discuss whether it should be verified or
>
>         rejected. When a decision is reached, the verifying party
>
>         can log in to change the status and edit the report, if necessary.
>
>         --------------------------------------
>
>         RFC8257 (draft-ietf-tcpm-dctcp-10)
>
>         --------------------------------------
>
>         Title               : Data Center TCP (DCTCP): TCP Congestion Control for Data Centers
>
>         Publication Date    : October 2017
>
>         Author(s)           : S. Bensley, D. Thaler, P. Balasubramanian, L. Eggert, G. Judd
>
>         Category            : INFORMATIONAL
>
>         Source              : TCP Maintenance and Minor Extensions
>
>         Area                : Transport
>
>         Stream              : IETF
>
>         Verifying Party     : IESG
>
>         _______________________________________________
>
>         tcpm mailing list
>
>         [email-masked]  <mailto:[email-masked]>
>
>         https://www.ietf.org/mailman/listinfo/tcpm  <https://nam06.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Ftcpm&data=04%7C01%7Cpravb%40microsoft.com%7C6adfa975d9744f6a289b08d984564c71%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637686328526119642%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=X63EYFpc%2FnO4Px7I61QHgopu4Qs09fOEYOhdWfeo%2F4U%3D&reserved=0>
>
>
>
>     -- 
>
>     ________________________________________________________________
>
>     Bob Briscoehttp://bobbriscoe.net/  <https://nam06.safelinks.protection.outlook.com/?url=http%3A%2F%2Fbobbriscoe.net%2F&data=04%7C01%7Cpravb%40microsoft.com%7C6adfa975d9744f6a289b08d984564c71%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637686328526119642%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=lG5TRWIlxHSVIj6gDXj1I83tHKCkcfWfcVr%2BgnzzomI%3D&reserved=0>
>
>     _______________________________________________
>     tcpm mailing list
>     [email-masked] <mailto:[email-masked]>
>     https://www.ietf.org/mailman/listinfo/tcpm
>     <https://www.ietf.org/mailman/listinfo/tcpm>
>

-- 
________________________________________________________________
Bob Briscoehttp://bobbriscoe.net/

---

From: Bob Briscoe <[email-masked]>
Date: Fri, 1 Oct 2021 14:12:33 +0100

Neal,

On 30/09/2021 16:43, Neal Cardwell wrote:
> I agree with the points made by Vidhi and Bob, and really like Bob's text.
>
> In the suggested text there may be a typo; I believe we want 
> s/SND.UNA/SND.NXT/.

[BB] Agree (and your next point about solely ECN indications).

I only said SND.UNA 'cos I was looking back at this earlier sentence in 
the RFC, and I copied the idea without engaging brain:

    o  DCTCP.WindowEnd: the TCP sequence number threshold when one
       observation window ends and another is to begin; initialized to
       SND.UNA.

Why does this say SND.UNA? Is this another erratum? I believe the Linux 
code initializes to SND.NXT in dctcp_reset(), which is called from 
dctcp_init():
https://elixir.bootlin.com/linux/v4.7/source/net/ipv4/tcp_dctcp.c#L78

BTW, step 7 correctly says SND.NXT:

    7.  Determine the end of the next observation window:

           DCTCP.WindowEnd = SND.NXT

Bob

> And probably we want to be more specific about only suppressing 
> further ECN-based reductions (further loss-triggered reductions would 
> be good to allow). I'm posting my suggested tweaks in blue, starting 
> from Bob's nice green text:
>
> SUGGESTED:
> ==========
>
>     [RFC3168]*, on the arrival of ECNcongestion feedback,*  the sender SHOULD
>     update cwnd as follows:
>
>     indications more than once for every window of data.*Therefore, as for RFC3168 ECN, it sets the variable for the end of 
> congestion  window reduced (CWR) state to SND.NXTand suppresses 
> further ECN-triggeredreductions until this TCP sequence number is 
> acknowledged. Periods  of CWR state are triggered by congestion 
> feedback, and therefore  occur at times unrelated to the continuous 
> cycle of observation  windows used to update DCTCP.Alpha in Section 3.3.*
>
> neal
> On Thu, Sep 30, 2021 at 11:22 AM Bob Briscoe <[email-masked] 
>         indications more than once for every window of data.*Therefore, as for RFC3168 ECN, it sets the variable for the end
>     of congestion  window reduced (CWR) state to SND.UNA and
>     suppresses further  reductions until this TCP sequence number is
>     acknowledged. Periods  of CWR state are triggered by congestion
>     feedback, and therefore  occur at times unrelated to the
>     continuous cycle of observation  windows used to update
>     DCTCP.Alpha in Section 3.3.*
>
>>     https://www.rfc-editor.org/errata/eid6697  <https://www.rfc-editor.org/errata/eid6697>
>>
>>     https://www.ietf.org/mailman/listinfo/tcpm  <https://www.ietf.org/mailman/listinfo/tcpm>
>
>     -- 
>     Bob Briscoehttp://bobbriscoe.net/  <http://bobbriscoe.net/>
>

-- 
________________________________________________________________
Bob Briscoe                               http://bobbriscoe.net/